#ifndef MAINTENANCE_H_
#define MAINTENANCE_H_

#include "config.h"
#include "meta.h"

class maintenance
{
public:
	maintenance(int fd);
	virtual ~maintenance();
	
	/*!
	 *  @brief Main execution method for maintenance tasks.
	 */
	virtual void Run(const MYSTD::string &cmd)=0;

protected:
	
	virtual void SendMsg(const MYSTD::string &x);
	virtual void SendMsg(const char *data, size_t size);
	bool _SendHelper(const char *data, size_t len, int flags);
	virtual void EndTransfer();
	MYSTD::string & GetHostname();
	
	void SendDecoration(bool bBegin, const char *httpcode="200", const char *szDecoFile=NULL);
	void SetStyle(MYSTD::string&);
	int m_reportFD;
	const char *m_szDecoFile;
private:
	maintenance(const maintenance&);
	maintenance& operator=(const maintenance&);
	MYSTD::string m_sHostname;
};


void DispatchAndRunMaintTask(const MYSTD::string &, int, const char*);

#endif /*MAINTENANCE_H_*/
